from typing import Any, List

import dream3d.simpl

class AddBadData(dream3d.simpl.AbstractFilter):
    BoundaryNoise: bool
    BoundaryVolFraction: float
    GBEuclideanDistancesArrayPath: dream3d.simpl.DataArrayPath
    PoissonNoise: bool
    PoissonVolFraction: float
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class AddOrientationNoise(dream3d.simpl.AbstractFilter):
    CellEulerAnglesArrayPath: dream3d.simpl.DataArrayPath
    Magnitude: float
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class EstablishMatrixPhase(dream3d.simpl.AbstractFilter):
    CellPhasesArrayName: str
    FeatureIdsArrayName: str
    FeaturePhasesArrayName: str
    InputPhaseNamesArrayPath: dream3d.simpl.DataArrayPath
    InputPhaseTypesArrayPath: dream3d.simpl.DataArrayPath
    InputStatsArrayPath: dream3d.simpl.DataArrayPath
    MaskArrayPath: dream3d.simpl.DataArrayPath
    NumFeaturesArrayName: str
    OutputCellAttributeMatrixPath: dream3d.simpl.DataArrayPath
    UseMask: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class EstablishShapeTypes(dream3d.simpl.AbstractFilter):
    InputPhaseTypesArrayPath: dream3d.simpl.DataArrayPath
    ShapeTypeData: List[dream3d.simpl.ShapeType]
    ShapeTypesArrayName: str
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class GeneratePrecipitateStatsData(dream3d.simpl.AbstractFilter):
    AppendToExistingAttributeMatrix: bool
    AxisOdfData: dream3d.simpl.DynamicTableData
    BinStepSize: float
    CellEnsembleAttributeMatrixName: str
    CreateEnsembleAttributeMatrix: bool
    CrystalSymmetry: int
    DataContainerName: dream3d.simpl.DataArrayPath
    MaxCutOff: float
    MdfData: dream3d.simpl.DynamicTableData
    MicroPresetModel: int
    MinCutOff: float
    Mu: float
    OdfData: dream3d.simpl.DynamicTableData
    PhaseFraction: float
    PhaseIndex: int
    PhaseName: str
    RdfBoxSize: dream3d.simpl.FloatVec3
    RdfMinMaxDistance: dream3d.simpl.FloatVec2
    RdfNumBins: int
    SelectedEnsembleAttributeMatrix: dream3d.simpl.DataArrayPath
    Sigma: float
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class GeneratePrimaryStatsData(dream3d.simpl.AbstractFilter):
    AppendToExistingAttributeMatrix: bool
    AxisOdfData: dream3d.simpl.DynamicTableData
    BinStepSize: float
    CellEnsembleAttributeMatrixName: str
    CreateEnsembleAttributeMatrix: bool
    CrystalSymmetry: int
    DataContainerName: dream3d.simpl.DataArrayPath
    MaxCutOff: float
    MdfData: dream3d.simpl.DynamicTableData
    MicroPresetModel: int
    MinCutOff: float
    Mu: float
    OdfData: dream3d.simpl.DynamicTableData
    PhaseFraction: float
    PhaseIndex: int
    PhaseName: str
    SelectedEnsembleAttributeMatrix: dream3d.simpl.DataArrayPath
    Sigma: float
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class InitializeSyntheticVolume(dream3d.simpl.AbstractFilter):
    CellAttributeMatrixName: str
    DataContainerName: dream3d.simpl.DataArrayPath
    Dimensions: dream3d.simpl.IntVec3
    EnsembleAttributeMatrixName: str
    EstimateNumberOfFeatures: bool
    GeometryDataContainer: dream3d.simpl.DataArrayPath
    GeometrySelection: int
    InputPhaseNamesArrayPath: dream3d.simpl.DataArrayPath
    InputPhaseTypesArrayPath: dream3d.simpl.DataArrayPath
    InputStatsArrayPath: dream3d.simpl.DataArrayPath
    LengthUnit: int
    Origin: dream3d.simpl.FloatVec3
    Spacing: dream3d.simpl.FloatVec3
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class InsertAtoms(dream3d.simpl.AbstractFilter):
    AtomFeatureLabelsArrayName: str
    AvgQuatsArrayPath: dream3d.simpl.DataArrayPath
    Basis: int
    LatticeConstants: dream3d.simpl.FloatVec3
    SurfaceMeshFaceLabelsArrayPath: dream3d.simpl.DataArrayPath
    VertexAttributeMatrixName: str
    VertexDataContainerName: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class InsertPrecipitatePhases(dream3d.simpl.AbstractFilter):
    AxisEulerAnglesArrayName: str
    AxisLengthsArrayName: str
    BoundaryCellsArrayPath: dream3d.simpl.DataArrayPath
    CellPhasesArrayPath: dream3d.simpl.DataArrayPath
    CentroidsArrayName: str
    CsvOutputFile: str
    EquivalentDiametersArrayName: str
    FeatureGeneration: int
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    FeaturePhasesArrayPath: dream3d.simpl.DataArrayPath
    InputPhaseTypesArrayPath: dream3d.simpl.DataArrayPath
    InputShapeTypesArrayPath: dream3d.simpl.DataArrayPath
    InputStatsArrayPath: dream3d.simpl.DataArrayPath
    MaskArrayPath: dream3d.simpl.DataArrayPath
    MatchRDF: bool
    NewAttributeMatrixPath: dream3d.simpl.DataArrayPath
    NumCellsArrayName: str
    NumFeaturesArrayPath: dream3d.simpl.DataArrayPath
    Omega3sArrayName: str
    PeriodicBoundaries: bool
    PrecipInputFile: str
    SaveGeometricDescriptions: int
    SelectedAttributeMatrixPath: dream3d.simpl.DataArrayPath
    UseMask: bool
    VolumesArrayName: str
    WriteGoalAttributes: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class JumbleOrientations(dream3d.simpl.AbstractFilter):
    AvgQuatsArrayName: str
    CellEulerAnglesArrayName: str
    FeatureEulerAnglesArrayPath: dream3d.simpl.DataArrayPath
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    FeaturePhasesArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class MatchCrystallography(dream3d.simpl.AbstractFilter):
    AvgQuatsArrayName: str
    CellEulerAnglesArrayName: str
    CrystalStructuresArrayPath: dream3d.simpl.DataArrayPath
    FeatureEulerAnglesArrayName: str
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    FeaturePhasesArrayPath: dream3d.simpl.DataArrayPath
    InputStatsArrayPath: dream3d.simpl.DataArrayPath
    MaxIterations: int
    NeighborListArrayPath: dream3d.simpl.DataArrayPath
    NumFeaturesArrayPath: dream3d.simpl.DataArrayPath
    PhaseTypesArrayPath: dream3d.simpl.DataArrayPath
    SharedSurfaceAreaListArrayPath: dream3d.simpl.DataArrayPath
    SurfaceFeaturesArrayPath: dream3d.simpl.DataArrayPath
    VolumesArrayName: str
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class PackPrimaryPhases(dream3d.simpl.AbstractFilter):
    CellPhasesArrayName: str
    CsvOutputFile: str
    FeatureGeneration: int
    FeatureIdsArrayName: str
    FeatureInputFile: str
    FeaturePhasesArrayName: str
    InputPhaseNamesArrayPath: dream3d.simpl.DataArrayPath
    InputPhaseTypesArrayPath: dream3d.simpl.DataArrayPath
    InputShapeTypesArrayPath: dream3d.simpl.DataArrayPath
    InputStatsArrayPath: dream3d.simpl.DataArrayPath
    MaskArrayPath: dream3d.simpl.DataArrayPath
    NewAttributeMatrixPath: dream3d.simpl.DataArrayPath
    NumFeaturesArrayName: str
    OutputCellAttributeMatrixPath: dream3d.simpl.DataArrayPath
    OutputCellEnsembleAttributeMatrixName: str
    OutputCellFeatureAttributeMatrixName: str
    PeriodicBoundaries: bool
    SaveGeometricDescriptions: int
    SelectedAttributeMatrixPath: dream3d.simpl.DataArrayPath
    UseMask: bool
    WriteGoalAttributes: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class StatsGeneratorFilter(dream3d.simpl.AbstractFilter):
    CellEnsembleAttributeMatrixName: str
    CrystalStructures: dream3d.simpl.UInt32Array
    CrystalStructuresArrayName: str
    Path: dream3d.simpl.DataArrayPath
    PhaseNames: dream3d.simpl.StringDataArray
    PhaseNamesArrayName: str
    PhaseTypes: dream3d.simpl.UInt32Array
    PhaseTypesArrayName: str
    StatsDataArray: dream3d.simpl.StatsDataArray
    StatsDataArrayName: str
    StatsGeneratorDataContainerName: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...
